# BASED ON PYPLACE - PRETTY MUCH DONE (BUT ASSUMES SHRINK IMAGES)

import gfx
from gameobj import FloorTile



class Cement(FloorTile):

    height = 5


    def init_data(self):
        pass


    def load_graphics(self):
        self.pix[0] = gfx.load("pave.png", self.path)
        self.pix["0_TOPLEFT"] = gfx.load("pave_TOPLEFT.png", self.path)
        self.pix["0_TOPRIGHT"] = gfx.load("pave_TOPRIGHT.png", self.path)
        self.pix["0_TOP"] = gfx.load("pave_TOP.png", self.path)
        self.quick_tiles = True


class Grass(FloorTile):

    height = 0

   
    def init_data(self):
        pass


    def load_graphics(self):
        img_num = 0
        while True:
            try:
                self.pix[img_num] = gfx.load("grass" + str(img_num) + ".png", self.path)
                img_num += 1
            except:
                break
                
        self.random_range = img_num



class Curb(FloorTile):

    height = 11


    def init_data(self):
        pass


    # note that graphics with height need a mask version for rendering to be quick
    # it will work anyway, but slowly.
    # render.py uses _MASK graphic if possible to speed rendering
    def load_graphics(self):
        self.pix[0] = gfx.load("curb.png", self.path)
        self.pix["0_TOPLEFT"] = gfx.load("curb_TOPLEFT.png", self.path)
        self.pix["0_TOPRIGHT"] = gfx.load("curb_TOPRIGHT.png", self.path)
        self.pix["0_TOP"] = gfx.load("curb_TOP.png", self.path)

        self.quick_tiles = True

      
class Void(FloorTile):

    height = 0
    
    
    def init_data(self):
        pass


    def load_graphics(self):
        img_num = 0
        while True:
            try:
                filename = "void" + str(img_num) + ".png"
                self.pix[img_num] = gfx.load(filename, self.path)
                imgnum += 1
            except:
                break
        self.random_range = img_num


OBJECTS = {
    "cement": Cement,
    "grass" : Grass,
    "curb"  : Curb,
    "void"  : Void,
}
