import gfx
from gameobj import ActorTile
from cyclepath import CyclePath

# move to constants module

TILE_GRID_SIZE = 16
TILE_SIZE = 60, 30

class Sphere(ActorTile):


    def init_data(self):

        self.mx = TILE_GRID_SIZE / 2
        self.my = TILE_GRID_SIZE / 2

        # override

        self.fine_steps = 8

        self.cycle_path = CyclePath(self)
        self.cycle_path.set_state(peek_steps=6, can_climb=7)


    def load_graphics(self):

        img_num = 0
      
        while True:
            try:
                self.pix[img_num] = gfx.load("sphereA" + str(img_num) + ".png", self.path)
                img_num += 1
            except:
                break
            
        self.random_range = img_num
      
        x, y, w, h = self.pix[0].get_rect()
        self.ix = (TILE_SIZE[0] - w) / 2
        self.iy = 2 - TILE_SIZE[1]


    def do_action(self, coord, actor):
        return self.ride_cycle(coord)



OBJECTS = {
   "sphere"     : Sphere,
}
