# BASED ON PYPLACE - IN PROGRESS

# @@@ need to put this globally:

DEBUG = False

TILE_GRID_SIZE = 16
TILE_GRID_MIN = 0
TILE_GRID_MAX = TILE_GRID_SIZE - 1


MSG_TABLE = {
   'UL'  :  ("moverel", (-1, 0)),
   'U'   :  ("moverel", (-1, -1)),
   'UR'  :  ("moverel", (0, -1)),
   'L'   :  ("moverel", (-1, 1)),
   'R'   :  ("moverel", (1, -1)),
   'DL'  :  ("moverel", (0, 1)),
   'D'   :  ("moverel", (1, 1)),
   'DR'  :  ("moverel", (1, 0)),
}


def normalised_move_abs(x, y, mx, my):
    (new_x, new_y, new_mx, new_my) = (x, y, mx, my)
    while new_mx < TILE_GRID_MIN:
        new_mx += TILE_GRID_SIZE
        new_x -= 1
    while new_mx > TILE_GRID_MAX:
        new_mx -= TILE_GRID_SIZE
        new_x += 1
    while new_my < TILE_GRID_MIN:
        new_my += TILE_GRID_SIZE
        new_y -= 1
    while new_my > TILE_GRID_MAX:
        new_my -= TILE_GRID_SIZE
        new_y += 1
    return (new_x, new_y, new_mx, new_my)


def normalised_move_rel_fine(x, y, mx, my, dx, dy, x_peek, y_peek):
    (peek_x, peek_y, drop_mx, drop_my) = normalised_move_abs(x, y, mx + x_peek, my + y_peek)
    return normalised_move_abs(x, y, mx + dx, my + dy) + (peek_x, peek_y)



class State:
    pass
    

class CyclePath:
    
    
    def __init__(self, actor):
        self.actor = actor
        self.state = State()
        self.state.pedal = None
        self.state.moving = False
        self.state.locked = False
        self.state.dx = 0
        self.state.dy = 0
        
        
    def set_state(self, **d):
        self.state.__dict__.update(d)
        
    
    def msg(self, place, action, **params):
    
        self.place = place # @@@ need a better way of doing this
        
        cmd, args = MSG_TABLE[action]
        if cmd == "moverel":
            self.move_rel(*args, **params)
            
            
    def move_rel(self, mul_x, mul_y, **params):
        if not self.state.locked:
            fine_steps = self.actor.fine_steps
            self.state.dx = (0.0 + (mul_x * TILE_GRID_SIZE)) / fine_steps
            self.state.dy = (0.0 + (mul_y * TILE_GRID_SIZE)) / fine_steps
            
            if params.get("one_step"):
                self.state.locked = True
                self.num_steps = fine_steps
            else:
                self.num_steps = -1

            self.state.moving = True


    def ride(self, coords):
        (x, y) = coords
        
        if self.state.moving:
            (dx, dy) = (self.state.dx, self.state.dy)
            peek = self.state.peek_steps

            if self.num_steps == 0:
                self.state.locked = False
                self.state.moving = False
                
            if self.num_steps > 0:
                self.num_steps -= 1
                
            (x_peek, y_peek) = (0, 0)
            
            if dx:
                x_peek = peek * (dx / abs(dx))
                
            if dy:
                y_peek = peek * (dy / abs(dy))
                
            new_x, new_y, new_mx, new_my, peek_x, peek_y = normalised_move_rel_fine(x, y, self.actor.mx, self.actor.my, dx, dy, x_peek, y_peek)

            if peek_x != x or peek_y != y:
                now_height = self.place.height(coords)
                flag_stop = False
                new_height = self.place.height((peek_x, peek_y))
                
                if DEBUG: print new_height, now_height, self.state.can_climb
                
                if abs(new_height - now_height) > self.state.can_climb:
                    flag_stop = True

                if peek_x != x:
                    check_height = self.place.height((x, peek_y))
                    if abs(check_height - now_height) > self.state.can_climb:
                        flag_stop = True

                if peek_y != y:
                    check_height = self.place.height((peek_x, y))
                    if abs(check_height - now_height) > self.state.can_climb:
                        flag_stop = True

                if flag_stop:
                    self.state.moving = False
                    self.state.locked = False
                    
        if not self.state.moving:
            pass # @@@ ready hook
        else:
            (x, y) = (new_x, new_y)
            (self.actor.mx, self.actor.my) = (new_mx, new_my)
            self.actor.moved = True
            
        return (x, y)