# BASED ON PYPLACE - POSSIBLY COMPLETE

import pygame.image
import pygame.surfarray as surfarray

from pygame import HWSURFACE, RLEACCEL

import data

IMGPREFIX = "BIG_"

def load(name, path=None, tile=True):

    if tile:
        img = _load_raw(IMGPREFIX + name, path)
        img = halve_image(img)
    else:
        img = _load_raw(name, path)
    
    if not img.get_flags() & HWSURFACE:
        transparentcolourkey = 255, 0, 0
        img.set_colorkey(transparentcolourkey, RLEACCEL)
    
    return img.convert()
    

def halve_image(img):
    img_array = surfarray.array3d(img)
    (src_maxx, src_maxy) = img.get_size()
    small_pic = pygame.Surface((src_maxx >> 1, src_maxy >> 1))
    surfarray.blit_array(small_pic, img_array[:-1:2, :-1:2])
    if not small_pic.get_flags() & HWSURFACE:
        transparentcolourkey = 255,0,0
        small_pic.set_colorkey(transparentcolourkey, RLEACCEL)
    return small_pic

_LOADED_IMAGES = {}


def _load_raw(name, path):
    return _LOADED_IMAGES.setdefault(name + path, pygame.image.load(data.name(name, path)))