# BASED ON PYPLACE - ALMOST COMPLETE

import pygame.display
from pygame import *

import gameobj
import mylevel
import render
import fpsclock


def main():

    SCREEN_SIZE = (800, 600)
    
    pygame.init()

    screen = pygame.display.set_mode(SCREEN_SIZE)
    
    game_objects = gameobj.GameObjects()
      
    game_objects.load_backgrounds("background")

    level = mylevel.level_zero(screen, game_objects)

    do_whole_screen = True

    clock = fpsclock.Clock(20, True)
    
    game_objects.load_floor("floor")
    game_objects.load_props("prop")
    
    view_port = render.ViewPort((4, 4))
    view_area = Rect(6, 8, 680, 450)
    view_port.set_viewarea(view_area)
    
    level = mylevel.level_one(screen, game_objects)
    level.set_viewport(view_port)

    # game states
    GS_INSTRUCTIONS = 1
    GS_PLAY         = 2
    GS_EXIT         = 3
    
    gamestate = GS_INSTRUCTIONS
    
    while gamestate != GS_EXIT:

        if gamestate == GS_INSTRUCTIONS:
        
            level.instructions()
            dirtyrects = [view_area]
            
            # set clip to entire display surface
            screen.set_clip()
            
            pygame.display.update(dirtyrects)
        
            while True:
                event = pygame.event.poll()
                if event.type == QUIT:
                    gamestate = GS_EXIT
                    break
                elif event.type == KEYDOWN:
                    if event.key == K_ESCAPE:
                        gamestate = GS_EXIT
                        break
                    if event.key == K_SPACE:
                        gamesate = GS_PLAY
                        break
                elif event.type == MOUSEBUTTONDOWN:
                    gamestate = GS_PLAY
                    break
                    
                clock.tick()
                
                dirtyrects = []
                do_whole_screen = False
                
        elif gamestate == GS_PLAY:
        
            level.ready()
        
            while True:
                dirtyrects = []
                event = pygame.event.poll()
                
                if event.type == QUIT:
                    gamestate = GS_EXIT
                    break
                elif event.type == MOUSEBUTTONDOWN:
                    level.__onclick__(event.pos)
                elif event.type == MOUSEBUTTONUP:
                    level.__unclick__(event.pos)
                    
                level.turn()
                
                screen.set_clip(view_area)
                dirtyrects += render.render(level, screen, view_port, whole_screen=do_whole_screen)
                screen.set_clip()

                dirtyrects += level.__render__()
                pygame.display.update(dirtyrects)
                
                clock.tick()
                dirtyrect = []
                do_whole_screen = False
                

if __name__ == "__main__":
    main()