
# BASED ON PYPLACE - SOMEWHAT COMPLETE

from level import Level
from widgets import DirectionButtons
from gameobj import FloorTile

from pygame import Rect

DEBUG = True


class level_zero(Level):


    def __init__(self, surface, game_objects):
        Level.__init__(self, surface, game_objects)

        self.load_background("background", "L0_loading")
        self.scroll_allowed = False


        
class level_one(Level):

    my_widget = None
    

    def __init__(self, surface, game_objects):

        Level.__init__(self, surface, game_objects)
        
        self.load_background("background", "L1_loading")
        self.scroll_allowed = False
        self.selected_actor = 1

        self.build()
        
        
    def build(self):
        coord = (0, 0)
        map_text = """
=CCCCCCCCCC
=CggggggggC
=CgccggccgC
=CgcggggcgC
=CgggCCgggC
=CgcggggcgC
=CgccgcccgC
=CggggggggC
=CCCCCCCCCC
"""
        Level.build(self, coord, map_text)

        # actor
        x, y = 4, 3
        actor_id = 1
        prop = "sphere"
        
        if DEBUG: print "new actor", x, y, actor_id, prop
        self.add_actor((x, y), actor_id, prop)        


    def instructions(self):
        self.load_background("background", "L1_instructions")
        
        
    def ready(self):
        self.load_background("background", "L1_game")
        
        self.my_widget = DirectionButtons(Rect(695, 252, 96, 96), "redarrow", num_directions=8, action=self.clicked_redbutton, group_id=self.selected_actor)
        
        self.my_widget = DirectionButtons(Rect(695, 364, 96, 96), "bluearrow", num_directions=4, action=self.clicked_bluebutton, group_id=self.selected_actor)
        
        
    def clicked_redbutton(self, group_id, button_id):
        if DEBUG: print "RED BUTTON", group_id, button_id
        self.msg(action=button_id, group_id=group_id, one_step=True)
        
        
    def clicked_bluebutton(self, group_id, button_id):
        if DEBUG: print "BLUE BUTTON", group_id, button_id
        self.msg(action=button_id, group_id=group_id, one_step=False)
    
    
    def msg(self, action=None, group_id=None, **params):
        Level.msg(self, action, group_id, **params)