
# BASED ON PYPLACE - NOT COMPLETE

from Numeric import resize, array, zeros

from pygame import Rect

# previously in gamedeps.py
TILE_SIZE = 60, 30

TILE_SIZE_DIV2 = 30, 15

TILE_GRID_SIZE = 16
TILE_GRID_MIN = 0
TILE_GRID_MAX = TILE_GRID_SIZE - 1

PIXEL_OFFSET = []
stepx = (0.0 + TILE_SIZE_DIV2[0]) / TILE_GRID_SIZE
stepy = (0.0 + TILE_SIZE_DIV2[1]) / TILE_GRID_SIZE
for iy in range(TILE_GRID_MIN, TILE_GRID_MAX + 1):
    y_pixel_offset_x = -(iy * stepx)
    y_pixel_offset_y = iy * stepy
    row = []
    for ix in range(TILE_GRID_MIN, TILE_GRID_MAX + 1):
        x_pixel_offset_x = ix * stepx
        x_pixel_offset_y = ix * stepy
        row.append( (int(x_pixel_offset_x+y_pixel_offset_x),
                     int(x_pixel_offset_y+y_pixel_offset_y)) )
    PIXEL_OFFSET.append(row)

# end gamedeps.py stuff

first_time = True

RENDER_HEIGHT_MAP = 0

MAPF_BIT_SHOW_TOP = 0x8000
MAPF_BIT_SHOW_RIGHT = 0x4000
MAPF_BIT_SHOW_LEFT = 0x2000

MAPF_BITS_SHOW_TOPLEFT = MAPF_BIT_SHOW_TOP | MAPF_BIT_SHOW_LEFT
MAPF_BITS_SHOW_TOPRIGHT = MAPF_BIT_SHOW_TOP | MAPF_BIT_SHOW_RIGHT

MAPF_BITS_SHOW = MAPF_BIT_SHOW_TOP | MAPF_BIT_SHOW_RIGHT | MAPF_BIT_SHOW_LEFT

MAPF_BIT_ACTOR = 0x1000
MAPF_BIT_VISIBLE = 0x0800

MAPF_NEEDS_DRAWING = MAPF_BITS_SHOW | MAPF_BIT_ACTOR

MAPF_MASK_HEIGHT = 0x00ff

class ViewPort:

    def __init__(self, pos):
        self.view_area = None
        self.set_pos(pos)
        
    
    def set_pos(self, pos):
        self.pos = list(pos)
        self.scroll = [0, 0]
        self.total_scroll = [0, 0]
        
        
    def set_viewarea(self, view_area):
        self.view_area = view_area
        
    
def initialise_heights(place):
    global heights_initialised, RENDER_HEIGHT_MAP
    global place_max_x, place_max_y, place_height
    (place_max_x, place_max_y, place_height) = place.sizes
    RENDER_HEIGHT_MAP = resize(array((0)), (place_max_x, place_max_y))
    for y in range(place_max_y):
        for x in range(place_max_x):
            ht = place.height((x, y))
            RENDER_HEIGHT_MAP[x, y] = ht + 1
    
        
def render(place, surface, view_port, whole_screen):

    if whole_screen:
        dirty_rects = [Rect(10, 10, 680, 450)]  # @@@ externalise?
    else:
        dirty_rects = []

    actors = place.actors_at
    
    clip = surface.get_clip()

    tiles_x = (clip.width / TILE_SIZE[0]) + 4
    tiles_y = int(clip.height / (TILE_SIZE[1] / 2)) + 4
    
    d_start_x = -(tiles_x / 2) - (tiles_y / 4) - 2
    start_x = view_port.pos[0] + d_start_x
    
    d_start_y = (tiles_x / 2) - (tiles_y / 4)
    start_y = view_port.pos[1] + d_start_y

    pix_start_x = view_port.scroll[0] + clip.left - int(TILE_SIZE[0] * 2.5)
    pix_start_y = view_port.scroll[1] + clip.top - int(TILE_SIZE[1] * 1.5)
       
    global first_time
    
    if first_time:
        initialise_heights(place)
        
        view_port.tiles_x = tiles_x
        view_port.tiles_y = tiles_y
        view_port.d_start_x = d_start_x + 8
        view_port.d_start_y = d_start_y - 1
        view_port.pix_start_x = pix_start_x
        view_port.pix_start_y = pix_start_y

        first_time = False

    (place_max_x, place_max_y, place_height) = place.sizes

    (mapf_ox, mapf_oy) = (5, 5)      # generous off-map border
   
    mapf = zeros((place_max_x + 2 * mapf_ox, place_max_y + 2 * mapf_oy))
    mapf[mapf_ox:mapf_ox+place_max_x, mapf_oy:mapf_oy+place_max_y] = RENDER_HEIGHT_MAP
    actor_prop_positions = []
    
    for screen_y in range(tiles_y):
        tiles_in_row = tiles_x + (tiles_y % 2)
        map_x = start_x + ((screen_y) / 2) - 1
        map_y = start_y + ((screen_y + 1) / 2) + 1
        for screen_x in range(tiles_in_row):
            map_x += 1
            map_y -= 1
            index = (map_x, map_y)
            
            actor_list = place.actors_at.get(index, None)
            actor_mapf_x = mapf_ox + map_x
            actor_mapf_y = mapf_oy + map_y
    
            mapf[actor_mapf_x, actor_mapf_y] |= MAPF_BIT_VISIBLE

            if actor_list:
                actors_rect = None
                for actor_id in actor_list:
                    if actor_id:
                        actor = place.actor(actor_id)
                        pix_ref = actor.get("pix_ref", 0)
                        prop = actor["prop"]
                        if not prop.moved:
                            continue
                        prop.moved = False
                        actor_img = prop.pix[pix_ref]
                        actor_img_rect = actor_img.get_rect()
                        
                        (pixel_off_x, pixel_off_y) = PIXEL_OFFSET[int(prop.my)][int(prop.mx)]
                        pixel_off_y -= mapf[actor_mapf_x, actor_mapf_y] & MAPF_MASK_HEIGHT
                        actor_img_rect.move_ip(pixel_off_x - TILE_SIZE_DIV2[0], pixel_off_y - TILE_SIZE_DIV2[1])
                        
                        if not actors_rect:
                            actors_rect = actor_img_rect
                        else:
                            actors_rect.union(actor_img_rect)
                            
                    dr_x_min = int(actors_rect[0] / TILE_SIZE_DIV2[0])
                    dr_x_max = int((actors_rect[2] - actors_rect[0]) / TILE_SIZE_DIV2[0])
                    dr_y_max = int((actors_rect[3] - actors_rect[1]) / TILE_SIZE_DIV2[1])
                    
                    possibles = [(0, 0)]
                    if dr_y_max >= 3:
                        possibles.append((-2, -2))
                        actor_prop_positions.append((actor_mapf_x - 2, actor_mapf_y - 2))
                    if dr_y_max >= 2:
                        if dr_x_min < 0:
                            possibles.append((-2,-1))
                            actor_prop_positions.append((actor_mapf_x-2,actor_mapf_y-1))
                    if dr_x_max > 0:
                            possibles.append((-1,-2))
                            actor_prop_positions.append((actor_mapf_x-1,actor_mapf_y-2))
                    if dr_y_max >= 1:
                        possibles.append((-1,-1))
                        actor_prop_positions.append((actor_mapf_x-1,actor_mapf_y-1))
                        if dr_x_min < -1:
                            possibles.append((-2,0))
                            actor_prop_positions.append((actor_mapf_x-2,actor_mapf_y))
                        if dr_x_max > 1:
                            possibles.append((0,-2))
                            actor_prop_positions.append((actor_mapf_x,actor_mapf_y-2))
                    if dr_y_max >= 0:
                        if dr_x_min < 0:
                            possibles.append((-1,0))
                            actor_prop_positions.append((actor_mapf_x-1,actor_mapf_y))
                        if dr_x_max > 0:
                            possibles.append((0,-1))
                            actor_prop_positions.append((actor_mapf_x,actor_mapf_y-1))
                    for poss in possibles:
                        mapf[actor_mapf_x + poss[0],actor_mapf_y + poss[1]] |= MAPF_BIT_ACTOR | MAPF_BITS_SHOW

    done = {}

    new_try_list = {} # @@@ really just a set

    for position in actor_prop_positions:
        new_try_list[position] = 1
   
    while new_try_list:
        try_list = new_try_list.keys()
        new_try_list = {}
        while try_list:
            idx_mapf = try_list.pop()
            (idx_x, idx_y) = idx_mapf
            if done.has_key(idx_mapf):
                if done[idx_mapf] == 2:
                    continue
                else:
                    done[idx_mapf] += 1
            else:
                done[idx_mapf] = 1
            src = mapf[idx_mapf]

            src_height = src & MAPF_MASK_HEIGHT
            if not whole_screen and not src & MAPF_NEEDS_DRAWING:
                continue
            try_next = []
            if src & MAPF_BIT_SHOW_LEFT:
                try_next.append( ((idx_x, idx_y + 1), MAPF_BITS_SHOW_TOPRIGHT) )
            if src & MAPF_BIT_SHOW_RIGHT:
                try_next.append( ((idx_x + 1, idx_y), MAPF_BITS_SHOW_TOPLEFT) )
            try_next.append( ((idx_x + 1, idx_y + 1), MAPF_BITS_SHOW_TOPLEFT |MAPF_BITS_SHOW_TOPRIGHT) )
         
            for (idx_trg, merge_bit) in try_next:
                trg = mapf[idx_trg]
                if trg & MAPF_MASK_HEIGHT == 1:
                    if not src & MAPF_BIT_ACTOR:
                        continue
                    else:
                        mapf[idx_trg] |= MAPF_BITS_SHOW
                else:
                    mapf[idx_trg] |= merge_bit
                new_try_list[idx_trg] = 1

    # draw

    for screen_y in range(tiles_y):
        pix_x = pix_start_x - (TILE_SIZE[0] / 2 * (screen_y % 2)) - TILE_SIZE[0]
        pix_y = pix_start_y + TILE_SIZE[1] + screen_y * (TILE_SIZE[1] / 2)
        screen_x_range = range(tiles_x + (tiles_y % 2))
        blit_bits = {}

        map_x = start_x + ((screen_y) / 2) - 1
        map_y = start_y + ((screen_y + 1) / 2) + 1
      
        for screen_x in screen_x_range:
            map_x += 1
            map_y -= 1
            pix_x += TILE_SIZE[0]
            draw_bits = mapf[mapf_ox + map_x, mapf_oy + map_y] & MAPF_NEEDS_DRAWING
            if not whole_screen:
                if not draw_bits:
                    continue
                                
            index = (map_x, map_y)
            
            (use_tile, use_floor, use_height, use_pix_ref) = place.at(index)
            img = None
            
            show_bits = draw_bits & MAPF_BITS_SHOW
         
            if (not whole_screen) and use_floor.quick_tiles:
                if draw_bits == MAPF_BITS_SHOW_TOPRIGHT:
                    img = use_floor[str(use_pix_ref) + "_TOPRIGHT"]
                elif draw_bits == MAPF_BITS_SHOW_TOPLEFT:
                    img = use_floor[str(use_pix_ref) + "_TOPLEFT"]
                elif draw_bits == MAPF_BIT_SHOW_RIGHT:
                    img = use_floor[str(use_pix_ref) + "_TOPRIGHT"]
                elif draw_bits == MAPF_BIT_SHOW_LEFT:
                    img = use_floor[str(use_pix_ref) + "_TOPLEFT"]
            if not img:
                img = use_floor[use_pix_ref]
            
            stuff = (index, pix_x, img, map_x, map_y)
         
            if not blit_bits.has_key(use_height):
                blit_bits[use_height] = []
            blit_bits[use_height].append(stuff)
      
        heights = blit_bits.keys()
        heights.sort()
      
        for blit_height in heights:
            blits_todo = blit_bits[blit_height]

            for (index, pix_x, img, map_x, map_y) in blits_todo:
                r = img.get_rect()
                r.bottomleft = pix_x, pix_y  # place on screen coords
                surface.blit(img, r)         # and draw
                dirty_rects.append(r)        # remember to tell video about it

            for (index, pix_x, img, map_x, map_y) in blits_todo:
                actor_list = actors.get(index, None)

                if actor_list:
                    for actor_id in actor_list:
                        if actor_id:
                            actor = place.actor(actor_id)
                            pix_ref = actor.get("pixref", 0)
                            prop = actor["prop"]
                            actor_img = prop.pix[pix_ref]
                            r = actor_img.get_rect()
                            (pixel_off_x, pixel_off_y) = PIXEL_OFFSET[int(prop.my)][int(prop.mx)]
                            a_pix_x = pix_x + prop.ix + pixel_off_x
                            a_pix_y = pix_y + prop.iy + pixel_off_y
                            a_pix_y -= blit_height
                            r.bottomleft = a_pix_x, a_pix_y
                            surface.blit(actor_img, r)

    return dirty_rects
   